Debian Bug report logs - #620191
initscripts: [patch] Please support top-level /run

version graph

Package: initscripts; Maintainer for initscripts is Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>; Source for initscripts is src:sysvinit.

Reported by: Roger Leigh <rleigh@debian.org>

Date: Wed, 30 Mar 2011 22:03:05 UTC

Severity: important

Tags: patch

Found in version sysvinit/2.88dsf-13.1

Fixed in version sysvinit/2.88dsf-13.3

Done: Roger Leigh <rleigh@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Wed, 30 Mar 2011 22:03:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@debian.org>:
New Bug report received and forwarded. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Wed, 30 Mar 2011 22:03:08 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: initscripts: [patch] Please support top-level /run
Date: Wed, 30 Mar 2011 23:00:57 +0100
[Message part 1 (text/plain, inline)]
Package: initscripts
Version: 2.88dsf-13.1
Severity: normal
Tags: patch

Note: blocked by #620157 and will require versioned dependency on
base-files once it adds top-level /run.

/run is a new cross-distribution location for the storage of
transient writable files needed from system startup to shutdown, but
which do not require preserving across reboots.  This location is
a replacement for several existing locations in the filesystem
hierarchy:

/var/run (→ /run)
/var/lock (→ /run/lock)
/lib/init/rw (→ /run/init)
/dev/.* (→ /run/*)
/dev/shm/.* (→ /run/*)
writable files under /etc (→ /run/*)

Note files abusing /dev and /dev/shm are in contravention of the
FHS; this provides a location for them in the heierarchy.  It
also provides a location for distribution-specific solutions such
as Debian's /lib/init/rw.  /run will be a cross-distribution location
and is now also used by Fedora/SuSE and others will also be using it.
It's also been proposed to the FHS for standardisation.

https://lwn.net/Articles/436012/
http://thread.gmane.org/gmane.linux.redhat.fedora.devel/146976
http://bugs.freestandards.org/show_bug.cgi?id=718
http://lists.debian.org/debian-devel/2011/03/msg01118.html
http://lists.debian.org/debian-devel/2011/03/msg01119.html
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=620157

The attached patch contains a detailed changelog of the changes, so
I won't repeat it here verbatim.  Outstanding issues are marked
TODO, and may require further discussion to resolve them.

One issue is how best to handle the transition for wheezy.  The
patch takes the most conservative approach, modelled on the
/lib/init/rw approach.  /run is not used until a system reboot, at
which point /etc/init/rcS.d will handle setup.  I create a
compatibility bind mount from /run/init to /lib/init/rw.  I've
currently left out bind mounts/symlink of /var/run and /var/lock;
I'd link to get consensus on how best to handle migration before
doing this last small bit.

We could bind mount if a directory, and create symlinks if not,
or they do not exist (to handle new installs).  But, base-files
will also need to drop these locations from itself so we can
co-opt them.

We could take a less conservative approach and do the migration in
one shot, setting up bind mounts from the existing locations to
/run, which would allow other packages to simply have a versioned
dependency on initscripts to start using /run, rather than waiting
until after wheezy to rely upon it.  But this has a much greater
potential for pain and trouble.  But is certainly feasible on
Linux by doing the following:

  check for /lib/init/rw/.ramfs
    (not in a chroot or bootstrap env; OK to continue)
  bind mount /var/run on /run
    create /run/init and /run/lock
  bind mount /var/lock on /run/lock
  bind mount /lib/init/rw on /run/init

However, we only want to do this once only on initial upgrade;
we don't want to repeat this, or do it following a reboot, or
else things will get seriously screwy.  Note it also needs to
cope with /var/lock and /var/run being symlinks or separately
mounted filesystems; if separately mounted we can mount --move
them and replace with symlinks.


Regards,
Roger

-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (550, 'unstable'), (400, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.38-1-amd64 (SMP w/4 CPU cores)
Locale: LANG=en_GB.utf8, LC_CTYPE=en_GB.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages initscripts depends on:
ii  coreutils                   8.5-1        GNU core utilities
ii  debianutils                 3.4.4        Miscellaneous utilities specific t
ii  libc6                       2.11.2-13    Embedded GNU C Library: Shared lib
ii  lsb-base                    3.2-27       Linux Standard Base 3.2 init scrip
ii  mount                       2.17.2-9.1   Tools for mounting and manipulatin
ii  sysv-rc                     2.88dsf-13.1 System-V-like runlevel change mech
ii  sysvinit-utils              2.88dsf-13.1 System-V-like utilities

Versions of packages initscripts recommends:
ii  e2fsprogs                     1.41.12-2  ext2/ext3/ext4 file system utiliti
ii  psmisc                        22.13-1    utilities that use the proc file s

initscripts suggests no packages.

-- no debconf information
[initscripts-run-transition-wip.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Thu, 31 Mar 2011 18:06:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Thu, 31 Mar 2011 18:06:03 GMT) Full text and rfc822 format available.

Message #10 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@debian.org>
To: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Thu, 31 Mar 2011 18:55:18 +0100
[Message part 1 (text/plain, inline)]
On Wed, Mar 30, 2011 at 11:00:57PM +0100, Roger Leigh wrote:
> The attached patch contains a detailed changelog of the changes, so
> I won't repeat it here verbatim.  Outstanding issues are marked
> TODO, and may require further discussion to resolve them.

Updated patch attached.  Handles upgrades and reboots; other than
the one outstanding TODO item (transition of /lib/init/rw from
directory to symlink, probably something we can leave until after
squeeze).


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[initscripts-run-transition-wip2.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Fri, 01 Apr 2011 09:00:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to sedat.dilek@gmail.com:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 01 Apr 2011 09:00:03 GMT) Full text and rfc822 format available.

Message #15 received at 620191@bugs.debian.org (full text, mbox):

From: Sedat Dilek <sedat.dilek@googlemail.com>
To: Roger Leigh <rleigh@debian.org>
Cc: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Fri, 1 Apr 2011 10:55:43 +0200
Resend (b0rked subject line, add TO BR initiator).

- Sedat -


---------- Forwarded message ----------
From: Sedat Dilek <sedat.dilek@googlemail.com>
Date: Fri, Apr 1, 2011 at 9:18 AM
Subject: Re: 620191@bugs.debian.org
To: 620191@bugs.debian.org


Hi,

[1] says:
...
I've filed a bug (#620191) against initscripts containing a proposed
patch for this.
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=620191

/var/run (→ /run)
/var/lock (→ /run/lock)
/lib/init/rw (→ /run/init)
/dev/.* (→ /run/*)
/dev/shm/.* (→ /run/*)
writable files under /etc (→ /run/*)
...

Whereas in "initscripts-run-transition-wip2.patch" I see:
...
diff -urN sysvinit-2.88dsf.original/debian/src/initscripts/Makefile
sysvinit-2.88dsf/debian/src/initscripts/Makefile
--- sysvinit-2.88dsf.original/debian/src/initscripts/Makefile   2011-03-30
16:46:27.675265266 +0100
+++ sysvinit-2.88dsf/debian/src/initscripts/Makefile    2011-03-30
16:54:07.988949558 +0100
@@ -10,7 +10,7 @@
 all:

 install:
-       $(INSTALL) -d $(DESTDIR)/lib/init/rw/.
+       ln -s /run $(DESTDIR)/lib/init/rw
...

Shouldn't that be?

ln -s /run/init $(DESTDIR)/lib/init/rw

Test-Case:

# mkdir -p /run/init
# ln -s /run/init /lib/init/rw-test
# touch /lib/init/rw-test/teschd

# ls -l /lib/init/rw-test
lrwxrwxrwx 1 root root 9  1. Apr 09:12 /lib/init/rw-test -> /run/init
# ls -l /run/init/
insgesamt 0
-rw-r--r-- 1 root root 0  1. Apr 09:16 teschd

- Sedat -

[1] http://lists.debian.org/debian-devel/2011/03/msg01150.html




Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Fri, 01 Apr 2011 09:39:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 01 Apr 2011 09:39:03 GMT) Full text and rfc822 format available.

Message #20 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: sedat.dilek@gmail.com
Cc: Roger Leigh <rleigh@debian.org>, 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Fri, 1 Apr 2011 10:36:20 +0100
[Message part 1 (text/plain, inline)]
On Fri, Apr 01, 2011 at 10:55:43AM +0200, Sedat Dilek wrote:
>  install:
> -       $(INSTALL) -d $(DESTDIR)/lib/init/rw/.
> +       ln -s /run $(DESTDIR)/lib/init/rw
> ...
> 
> Shouldn't that be?
> 
> ln -s /run/init $(DESTDIR)/lib/init/rw

Yes.  In my latest patch (to be submitted shortly), I have removed this
change since we can't replace a directory with a symlink on package
upgrade (since it has a mounted tmpfs on top of it).  We'll have to
do this part after wheezy is released.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Fri, 01 Apr 2011 13:21:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 01 Apr 2011 13:21:07 GMT) Full text and rfc822 format available.

Message #25 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: Roger Leigh <rleigh@debian.org>
Cc: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Fri, 1 Apr 2011 14:18:11 +0100
[Message part 1 (text/plain, inline)]
On Thu, Mar 31, 2011 at 06:55:16PM +0100, Roger Leigh wrote:
> On Wed, Mar 30, 2011 at 11:00:57PM +0100, Roger Leigh wrote:
> > The attached patch contains a detailed changelog of the changes, so
> > I won't repeat it here verbatim.  Outstanding issues are marked
> > TODO, and may require further discussion to resolve them.
> 
> Updated patch attached.  Handles upgrades and reboots; other than
> the one outstanding TODO item (transition of /lib/init/rw from
> directory to symlink, probably something we can leave until after
> squeeze).

Updated patch attached.  This one has been tested in a VM, and will
allow a machine to boot and transition to /run safely.

Minor outstanding issue:
/etc/init.d/mountall.sh fails.  This is due to (apparently) / and /proc
already being mounted, leading to a 32 exit status.  Maybe an mtab
issue?

In order to work properly with bind mounts on freebsd kernels, I've
synched domount and domtab logic so that they behave identically.
However, I'm seeing some odd double bind mounts in /proc/mounts
and an incomplete /etc/mtab, so there's possibly something not quite
right here.

Apart from this one issue, everything else is working fully.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[initscripts-run-transition3.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Fri, 01 Apr 2011 14:15:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 01 Apr 2011 14:15:06 GMT) Full text and rfc822 format available.

Message #30 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Fri, 1 Apr 2011 15:11:18 +0100
[Message part 1 (text/plain, inline)]
On Fri, Apr 01, 2011 at 02:18:11PM +0100, Roger Leigh wrote:
> On Thu, Mar 31, 2011 at 06:55:16PM +0100, Roger Leigh wrote:
> > On Wed, Mar 30, 2011 at 11:00:57PM +0100, Roger Leigh wrote:
> > > The attached patch contains a detailed changelog of the changes, so
> > > I won't repeat it here verbatim.  Outstanding issues are marked
> > > TODO, and may require further discussion to resolve them.
> > 
> > Updated patch attached.  Handles upgrades and reboots; other than
> > the one outstanding TODO item (transition of /lib/init/rw from
> > directory to symlink, probably something we can leave until after
> > squeeze).
> 
> Updated patch attached.  This one has been tested in a VM, and will
> allow a machine to boot and transition to /run safely.
> 
> Minor outstanding issue:
> /etc/init.d/mountall.sh fails.  This is due to (apparently) / and /proc
> already being mounted, leading to a 32 exit status.  Maybe an mtab
> issue?
> 
> In order to work properly with bind mounts on freebsd kernels, I've
> synched domount and domtab logic so that they behave identically.
> However, I'm seeing some odd double bind mounts in /proc/mounts
> and an incomplete /etc/mtab, so there's possibly something not quite
> right here.
> 
> Apart from this one issue, everything else is working fully.

Updated patch attached.  This fixes the above outstanding issues.
It should now be safe for general testing and use.

Note: needs versioned base-files dependency adding.


Thanks,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Fri, 01 Apr 2011 15:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 01 Apr 2011 15:21:05 GMT) Full text and rfc822 format available.

Message #35 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Fri, 1 Apr 2011 16:19:03 +0100
[Message part 1 (text/plain, inline)]
On Fri, Apr 01, 2011 at 03:11:18PM +0100, Roger Leigh wrote:
> On Fri, Apr 01, 2011 at 02:18:11PM +0100, Roger Leigh wrote:
> > On Thu, Mar 31, 2011 at 06:55:16PM +0100, Roger Leigh wrote:
> > > On Wed, Mar 30, 2011 at 11:00:57PM +0100, Roger Leigh wrote:
> > > > The attached patch contains a detailed changelog of the changes, so
> > > > I won't repeat it here verbatim.  Outstanding issues are marked
> > > > TODO, and may require further discussion to resolve them.
> > > 
> > > Updated patch attached.  Handles upgrades and reboots; other than
> > > the one outstanding TODO item (transition of /lib/init/rw from
> > > directory to symlink, probably something we can leave until after
> > > squeeze).
> > 
> > Updated patch attached.  This one has been tested in a VM, and will
> > allow a machine to boot and transition to /run safely.
> > 
> > Minor outstanding issue:
> > /etc/init.d/mountall.sh fails.  This is due to (apparently) / and /proc
> > already being mounted, leading to a 32 exit status.  Maybe an mtab
> > issue?
> > 
> > In order to work properly with bind mounts on freebsd kernels, I've
> > synched domount and domtab logic so that they behave identically.
> > However, I'm seeing some odd double bind mounts in /proc/mounts
> > and an incomplete /etc/mtab, so there's possibly something not quite
> > right here.
> > 
> > Apart from this one issue, everything else is working fully.
> 
> Updated patch attached.  This fixes the above outstanding issues.
> It should now be safe for general testing and use.
> 
> Note: needs versioned base-files dependency adding.

Updated patch attached; adds kfreebsd support to initscripts postinst.


-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[initscripts-run-transition5.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Fri, 01 Apr 2011 16:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 01 Apr 2011 16:45:03 GMT) Full text and rfc822 format available.

Message #40 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Fri, 1 Apr 2011 17:42:53 +0100
[Message part 1 (text/plain, inline)]
On Fri, Apr 01, 2011 at 04:19:03PM +0100, Roger Leigh wrote:
> On Fri, Apr 01, 2011 at 03:11:18PM +0100, Roger Leigh wrote:
> > On Fri, Apr 01, 2011 at 02:18:11PM +0100, Roger Leigh wrote:
> > > On Thu, Mar 31, 2011 at 06:55:16PM +0100, Roger Leigh wrote:
> > > > On Wed, Mar 30, 2011 at 11:00:57PM +0100, Roger Leigh wrote:
> > > > > The attached patch contains a detailed changelog of the changes, so
> > > > > I won't repeat it here verbatim.  Outstanding issues are marked
> > > > > TODO, and may require further discussion to resolve them.
> > > > 
> > > > Updated patch attached.  Handles upgrades and reboots; other than
> > > > the one outstanding TODO item (transition of /lib/init/rw from
> > > > directory to symlink, probably something we can leave until after
> > > > squeeze).
> > > 
> > > Updated patch attached.  This one has been tested in a VM, and will
> > > allow a machine to boot and transition to /run safely.
> > > 
> > > Minor outstanding issue:
> > > /etc/init.d/mountall.sh fails.  This is due to (apparently) / and /proc
> > > already being mounted, leading to a 32 exit status.  Maybe an mtab
> > > issue?
> > > 
> > > In order to work properly with bind mounts on freebsd kernels, I've
> > > synched domount and domtab logic so that they behave identically.
> > > However, I'm seeing some odd double bind mounts in /proc/mounts
> > > and an incomplete /etc/mtab, so there's possibly something not quite
> > > right here.
> > > 
> > > Apart from this one issue, everything else is working fully.
> > 
> > Updated patch attached.  This fixes the above outstanding issues.
> > It should now be safe for general testing and use.
> > 
> > Note: needs versioned base-files dependency adding.
> 
> Updated patch attached; adds kfreebsd support to initscripts postinst.

Updated postinst following feedback on #debian-devel:
- use uname rather than dpkg --print-architecture
- simplify conditional logic


-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[initscripts-run-transition6.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Fri, 01 Apr 2011 17:03:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 01 Apr 2011 17:03:04 GMT) Full text and rfc822 format available.

Message #45 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Fri, 1 Apr 2011 18:01:55 +0100
[Message part 1 (text/plain, inline)]
On Fri, Apr 01, 2011 at 05:42:53PM +0100, Roger Leigh wrote:
> On Fri, Apr 01, 2011 at 04:19:03PM +0100, Roger Leigh wrote:
> > On Fri, Apr 01, 2011 at 03:11:18PM +0100, Roger Leigh wrote:
> > > On Fri, Apr 01, 2011 at 02:18:11PM +0100, Roger Leigh wrote:
> > > > On Thu, Mar 31, 2011 at 06:55:16PM +0100, Roger Leigh wrote:
> > > > > On Wed, Mar 30, 2011 at 11:00:57PM +0100, Roger Leigh wrote:
> > > > > > The attached patch contains a detailed changelog of the changes, so
> > > > > > I won't repeat it here verbatim.  Outstanding issues are marked
> > > > > > TODO, and may require further discussion to resolve them.
> > > > > 
> > > > > Updated patch attached.  Handles upgrades and reboots; other than
> > > > > the one outstanding TODO item (transition of /lib/init/rw from
> > > > > directory to symlink, probably something we can leave until after
> > > > > squeeze).
> > > > 
> > > > Updated patch attached.  This one has been tested in a VM, and will
> > > > allow a machine to boot and transition to /run safely.
> > > > 
> > > > Minor outstanding issue:
> > > > /etc/init.d/mountall.sh fails.  This is due to (apparently) / and /proc
> > > > already being mounted, leading to a 32 exit status.  Maybe an mtab
> > > > issue?
> > > > 
> > > > In order to work properly with bind mounts on freebsd kernels, I've
> > > > synched domount and domtab logic so that they behave identically.
> > > > However, I'm seeing some odd double bind mounts in /proc/mounts
> > > > and an incomplete /etc/mtab, so there's possibly something not quite
> > > > right here.
> > > > 
> > > > Apart from this one issue, everything else is working fully.
> > > 
> > > Updated patch attached.  This fixes the above outstanding issues.
> > > It should now be safe for general testing and use.
> > > 
> > > Note: needs versioned base-files dependency adding.
> > 
> > Updated patch attached; adds kfreebsd support to initscripts postinst.
> 
> Updated postinst following feedback on #debian-devel:
> - use uname rather than dpkg --print-architecture
> - simplify conditional logic

Updated to
- not enable RAMLOCK by default (though doing so removes a DoS we
  are currently vulnerable to even with traditional /var)
- only use new paths in sendsigs
Thanks to mbiebl for this review.


-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[initscripts-run-transition7.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Sat, 02 Apr 2011 13:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Sat, 02 Apr 2011 13:30:03 GMT) Full text and rfc822 format available.

Message #50 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Sat, 2 Apr 2011 14:26:56 +0100
[Message part 1 (text/plain, inline)]
user rleigh@debian.org
usertag 620191 run-transition
usertag 620157 run-transition
severity 620191 important
severity 620157 important
block 620191 by 620157

On Fri, Apr 01, 2011 at 06:01:55PM +0100, Roger Leigh wrote:
> On Fri, Apr 01, 2011 at 05:42:53PM +0100, Roger Leigh wrote:
> > On Fri, Apr 01, 2011 at 04:19:03PM +0100, Roger Leigh wrote:
> > > On Fri, Apr 01, 2011 at 03:11:18PM +0100, Roger Leigh wrote:
> > > > On Fri, Apr 01, 2011 at 02:18:11PM +0100, Roger Leigh wrote:
> > > > > On Thu, Mar 31, 2011 at 06:55:16PM +0100, Roger Leigh wrote:
> > > > > > On Wed, Mar 30, 2011 at 11:00:57PM +0100, Roger Leigh wrote:
> > > > > > > The attached patch contains a detailed changelog of the changes, so
> > > > > > > I won't repeat it here verbatim.  Outstanding issues are marked
> > > > > > > TODO, and may require further discussion to resolve them.
> > > > > > 
> > > > > > Updated patch attached.  Handles upgrades and reboots; other than
> > > > > > the one outstanding TODO item (transition of /lib/init/rw from
> > > > > > directory to symlink, probably something we can leave until after
> > > > > > squeeze).
> > > > > 
> > > > > Updated patch attached.  This one has been tested in a VM, and will
> > > > > allow a machine to boot and transition to /run safely.
> > > > > 
> > > > > Minor outstanding issue:
> > > > > /etc/init.d/mountall.sh fails.  This is due to (apparently) / and /proc
> > > > > already being mounted, leading to a 32 exit status.  Maybe an mtab
> > > > > issue?
> > > > > 
> > > > > In order to work properly with bind mounts on freebsd kernels, I've
> > > > > synched domount and domtab logic so that they behave identically.
> > > > > However, I'm seeing some odd double bind mounts in /proc/mounts
> > > > > and an incomplete /etc/mtab, so there's possibly something not quite
> > > > > right here.
> > > > > 
> > > > > Apart from this one issue, everything else is working fully.
> > > > 
> > > > Updated patch attached.  This fixes the above outstanding issues.
> > > > It should now be safe for general testing and use.
> > > > 
> > > > Note: needs versioned base-files dependency adding.
> > > 
> > > Updated patch attached; adds kfreebsd support to initscripts postinst.
> > 
> > Updated postinst following feedback on #debian-devel:
> > - use uname rather than dpkg --print-architecture
> > - simplify conditional logic
> 
> Updated to
> - not enable RAMLOCK by default (though doing so removes a DoS we
>   are currently vulnerable to even with traditional /var)
> - only use new paths in sendsigs
> Thanks to mbiebl for this review.

Sorry for the patch flood.  Final (hopefully) patch attached following
some further discussion on #debian-devel.

Note: versioned base-files dependency may require tweaking; waiting
on base-files upload.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[initscripts-run-transition9.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Severity set to 'important' from 'normal' Request was from Roger Leigh <rleigh@codelibre.net> to control@bugs.debian.org. (Sat, 02 Apr 2011 13:36:04 GMT) Full text and rfc822 format available.

Added blocking bug(s) of 620191: 620157 Request was from Roger Leigh <rleigh@codelibre.net> to control@bugs.debian.org. (Sat, 02 Apr 2011 13:36:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Tue, 05 Apr 2011 17:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Tue, 05 Apr 2011 17:57:03 GMT) Full text and rfc822 format available.

Message #59 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Tue, 5 Apr 2011 18:55:18 +0100
[Message part 1 (text/plain, inline)]
On Sat, Apr 02, 2011 at 02:26:55PM +0100, Roger Leigh wrote:
> Sorry for the patch flood.  Final (hopefully) patch attached following
> some further discussion on #debian-devel.
> 
> Note: versioned base-files dependency may require tweaking; waiting
> on base-files upload.

Just to let you know, base-files 6.2 was uploaded today, with
/run as a new top-level directory.  This is the base-files
version we depend upon in debian/control, so the latest patch
provided should be good to go (initscripts-run-transition9.patch).

It would be great if this could be done soon, so that we can
start transitioning packages to use /run in place of /dev/.xxx
and /dev/shm/.xxx.  This means upstreams can implement the changes
now as other distributions are also doing the same transition.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[signature.asc (application/pgp-signature, inline)]

Added indication that bug 620191 blocks 620995 Request was from md@Linux.IT (Marco d'Itri) to control@bugs.debian.org. (Wed, 06 Apr 2011 01:03:12 GMT) Full text and rfc822 format available.

Added indication that bug 620191 blocks 620157 Request was from Michael Biebl <biebl@debian.org> to control@bugs.debian.org. (Thu, 07 Apr 2011 00:42:23 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Thu, 07 Apr 2011 14:52:24 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Thu, 07 Apr 2011 14:52:53 GMT) Full text and rfc822 format available.

Message #68 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Thu, 7 Apr 2011 15:46:20 +0100
[Message part 1 (text/plain, inline)]
On Tue, Apr 05, 2011 at 06:55:18PM +0100, Roger Leigh wrote:
> On Sat, Apr 02, 2011 at 02:26:55PM +0100, Roger Leigh wrote:
> > Sorry for the patch flood.  Final (hopefully) patch attached following
> > some further discussion on #debian-devel.
> > 
> > Note: versioned base-files dependency may require tweaking; waiting
> > on base-files upload.
> 
> Just to let you know, base-files 6.2 was uploaded today, with
> /run as a new top-level directory.  This is the base-files
> version we depend upon in debian/control, so the latest patch
> provided should be good to go (initscripts-run-transition9.patch).
> 
> It would be great if this could be done soon, so that we can
> start transitioning packages to use /run in place of /dev/.xxx
> and /dev/shm/.xxx.  This means upstreams can implement the changes
> now as other distributions are also doing the same transition.

Following the issues with udev using /run incorrectly, which caused
breakage when base-files introduced /run, I've adjusted the patch
to:

- provide /run directly
- remove the base-files dependency

Additionally, I've tested upgrades of this version on a live system
(I'm using it to write this mail; previous patches were tested in kvm
VMs).  It's working fine both before and after a reboot:

% mount
/dev/mapper/hufflepuff-root on / type ext3 (rw,relatime,user_xattr,errors=remount-ro)
tmpfs on /lib/init/rw type tmpfs (rw,nosuid,mode=0755)
tmpfs on /run type tmpfs (rw,nosuid,mode=0755)
proc on /proc type proc (rw,noexec,nosuid,nodev)
sysfs on /sys type sysfs (rw,noexec,nosuid,nodev)
udev on /dev type tmpfs (rw,mode=0755)
tmpfs on /dev/shm type tmpfs (rw,nosuid,nodev)
devpts on /dev/pts type devpts (rw,noexec,nosuid,gid=5,mode=620)
…

As you can see, /run is a tmpfs.

% ls /run
atd.pid                 cups               postgresql       sshd
avahi-daemon            dbus               radvd            sshd.pid
ConsoleKit              dhclient.eth0.pid  rsyslogd.pid     utmp
console-kit-daemon.pid  lock               samba            xdm.pid
crond.pid               motd               screen
crond.reboot            ntpd.pid           sendsigs.omit.d
hufflepuff% ls /run/lock
aumix

% ls -ld /run /run/lock
drwxr-xr-x 13 root root 500 Apr  7 15:38 /run
drwxrwxrwt  3 root root  80 Apr  7 15:38 /run/lock

% ls -ld /var/run /var/lock
lrwxrwxrwx 1 root root 9 Apr  7 15:38 /var/lock -> /run/lock
lrwxrwxrwx 1 root root 4 Apr  7 15:38 /var/run -> /run

As you can see, it's all set up correctly to be completely backward
compatible with /var/run and /var/lock, including directory
permissions.  All the system services using /var/run and /var/lock
are now transparently using /run and /run/lock via the compatibility
symlinks.


Summary: the patch is fine to upload now; there are no packages
we are waiting on for the transition.  The patch has been tested both
in VMs and on a live system, and has been found to work correctly.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Thu, 07 Apr 2011 15:27:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Thu, 07 Apr 2011 15:27:18 GMT) Full text and rfc822 format available.

Message #73 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Thu, 7 Apr 2011 15:48:16 +0100
[Message part 1 (text/plain, inline)]
On Thu, Apr 07, 2011 at 03:46:20PM +0100, Roger Leigh wrote:
> On Tue, Apr 05, 2011 at 06:55:18PM +0100, Roger Leigh wrote:
> > On Sat, Apr 02, 2011 at 02:26:55PM +0100, Roger Leigh wrote:
> > > Sorry for the patch flood.  Final (hopefully) patch attached following
> > > some further discussion on #debian-devel.
> > > 
> > > Note: versioned base-files dependency may require tweaking; waiting
> > > on base-files upload.
> > 
> > Just to let you know, base-files 6.2 was uploaded today, with
> > /run as a new top-level directory.  This is the base-files
> > version we depend upon in debian/control, so the latest patch
> > provided should be good to go (initscripts-run-transition9.patch).
> > 
> > It would be great if this could be done soon, so that we can
> > start transitioning packages to use /run in place of /dev/.xxx
> > and /dev/shm/.xxx.  This means upstreams can implement the changes
> > now as other distributions are also doing the same transition.
> 
> Following the issues with udev using /run incorrectly, which caused
> breakage when base-files introduced /run, I've adjusted the patch
> to:
> 
> - provide /run directly
> - remove the base-files dependency

Patch actually attached this time...

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[initscripts-run-transition10.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Fri, 08 Apr 2011 09:57:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 08 Apr 2011 09:57:26 GMT) Full text and rfc822 format available.

Message #78 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Fri, 8 Apr 2011 10:52:48 +0100
[Message part 1 (text/plain, inline)]
On Thu, Apr 07, 2011 at 03:46:20PM +0100, Roger Leigh wrote:
> On Tue, Apr 05, 2011 at 06:55:18PM +0100, Roger Leigh wrote:
> > On Sat, Apr 02, 2011 at 02:26:55PM +0100, Roger Leigh wrote:
> > > Sorry for the patch flood.  Final (hopefully) patch attached following
> > > some further discussion on #debian-devel.
> > > 
> > > Note: versioned base-files dependency may require tweaking; waiting
> > > on base-files upload.
> > 
> > Just to let you know, base-files 6.2 was uploaded today, with
> > /run as a new top-level directory.  This is the base-files
> > version we depend upon in debian/control, so the latest patch
> > provided should be good to go (initscripts-run-transition9.patch).
> > 
> > It would be great if this could be done soon, so that we can
> > start transitioning packages to use /run in place of /dev/.xxx
> > and /dev/shm/.xxx.  This means upstreams can implement the changes
> > now as other distributions are also doing the same transition.
> 
> Following the issues with udev using /run incorrectly, which caused
> breakage when base-files introduced /run, I've adjusted the patch
> to:
> 
> - provide /run directly
> - remove the base-files dependency

I've attached an updated patch; exactly the same as before, but with
a couple of typos in comments fixed (thanks to Michael Biebl for
reviewing it).

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[initscripts-run-transition11.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Added indication that bug 620191 blocks 621503 Request was from "Roger Leigh" <rl522@york.ac.uk> to control@bugs.debian.org. (Fri, 08 Apr 2011 13:58:02 GMT) Full text and rfc822 format available.

Removed blocking bug(s) of 620191: 620157 Request was from Michael Biebl <biebl@debian.org> to control@bugs.debian.org. (Sat, 09 Apr 2011 01:27:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Wed, 13 Apr 2011 00:06:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Wed, 13 Apr 2011 00:06:07 GMT) Full text and rfc822 format available.

Message #87 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Wed, 13 Apr 2011 01:02:02 +0100
[Message part 1 (text/plain, inline)]
On Fri, Apr 08, 2011 at 10:52:48AM +0100, Roger Leigh wrote:
> I've attached an updated patch; exactly the same as before, but with
> a couple of typos in comments fixed (thanks to Michael Biebl for
> reviewing it).

Updated patch attached.  Based on the patch series in this
temporary git repo (created for just this work):
http://git.debian.org/?p=collab-maint/sysvinit;a=summary
git://git.debian.org/collab-maint/sysvinit

This patch adds a number of fixes, and additionally also
migrates /dev/shm to /run/shm.  It also adds the ability to
mount /tmp as a tmpfs with RAMTMP=yes, and have /run/shm
use the main /run tmpfs with RAMSHM=no.

I also went through the initscripts bugs with mbiebl, and
this closes 15 bugs which /run and the associated changes
fix.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[initscripts-run-transition12.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#620191; Package initscripts. (Wed, 13 Apr 2011 11:37:20 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Wed, 13 Apr 2011 11:37:23 GMT) Full text and rfc822 format available.

Message #92 received at 620191@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 620191@bugs.debian.org
Subject: Re: initscripts: [patch] Please support top-level /run
Date: Wed, 13 Apr 2011 12:34:10 +0100
[Message part 1 (text/plain, inline)]
On Wed, Apr 13, 2011 at 01:02:02AM +0100, Roger Leigh wrote:
> On Fri, Apr 08, 2011 at 10:52:48AM +0100, Roger Leigh wrote:
> > I've attached an updated patch; exactly the same as before, but with
> > a couple of typos in comments fixed (thanks to Michael Biebl for
> > reviewing it).
> 
> Updated patch attached.  Based on the patch series in this
> temporary git repo (created for just this work):
> http://git.debian.org/?p=collab-maint/sysvinit;a=summary
> git://git.debian.org/collab-maint/sysvinit
> 
> This patch adds a number of fixes, and additionally also
> migrates /dev/shm to /run/shm.  It also adds the ability to
> mount /tmp as a tmpfs with RAMTMP=yes, and have /run/shm
> use the main /run tmpfs with RAMSHM=no.
> 
> I also went through the initscripts bugs with mbiebl, and
> this closes 15 bugs which /run and the associated changes
> fix.

Patch rebased on top of Christian's NMU.  Also added special
handling for /tmp and a symlink and added default size and
mode for each tmpfs in /etc/default/tmpfs and removed mode
hardcoding from scripts.


-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[initscripts-run-transition13.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Reply sent to Roger Leigh <rleigh@debian.org>:
You have taken responsibility. (Sat, 16 Apr 2011 16:09:39 GMT) Full text and rfc822 format available.

Notification sent to Roger Leigh <rleigh@debian.org>:
Bug acknowledged by developer. (Sat, 16 Apr 2011 16:09:39 GMT) Full text and rfc822 format available.

Message #97 received at 620191-close@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@debian.org>
To: 620191-close@bugs.debian.org
Subject: Bug#620191: fixed in sysvinit 2.88dsf-13.3
Date: Sat, 16 Apr 2011 16:08:33 +0000
Source: sysvinit
Source-Version: 2.88dsf-13.3

We believe that the bug you reported is fixed in the latest version of
sysvinit, which is due to be installed in the Debian FTP archive:

initscripts_2.88dsf-13.3_amd64.deb
  to main/s/sysvinit/initscripts_2.88dsf-13.3_amd64.deb
sysv-rc_2.88dsf-13.3_all.deb
  to main/s/sysvinit/sysv-rc_2.88dsf-13.3_all.deb
sysvinit-utils_2.88dsf-13.3_amd64.deb
  to main/s/sysvinit/sysvinit-utils_2.88dsf-13.3_amd64.deb
sysvinit_2.88dsf-13.3.diff.gz
  to main/s/sysvinit/sysvinit_2.88dsf-13.3.diff.gz
sysvinit_2.88dsf-13.3.dsc
  to main/s/sysvinit/sysvinit_2.88dsf-13.3.dsc
sysvinit_2.88dsf-13.3_amd64.deb
  to main/s/sysvinit/sysvinit_2.88dsf-13.3_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 620191@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Roger Leigh <rleigh@debian.org> (supplier of updated sysvinit package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: RIPEMD160

Format: 1.8
Date: Sat, 16 Apr 2011 01:17:29 +0100
Source: sysvinit
Binary: sysvinit sysvinit-utils sysv-rc initscripts
Architecture: source amd64 all
Version: 2.88dsf-13.3
Distribution: experimental
Urgency: low
Maintainer: Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>
Changed-By: Roger Leigh <rleigh@debian.org>
Description: 
 initscripts - scripts for initializing and shutting down the system
 sysv-rc    - System-V-like runlevel change mechanism
 sysvinit   - System-V-like init utilities
 sysvinit-utils - System-V-like utilities
Closes: 186892 353943 378776 406685 423405 481546 483643 503805 530582 564635 585543 599241 599734 607136 612594 616571 620191 620735
Changes: 
 sysvinit (2.88dsf-13.3) experimental; urgency=low
 .
   [ Roger Leigh ]
   * Non-maintainer upload.
   * Support for new top-level directory /run to replace /var/run,
     /var/lock, /dev/shm and /lib/init/rw as a place to store transient
     writable data which should not be preserved across a system
     reboot (Closes: #186892, #616571, #620191).  /run fixes existing
     issues with RAMRUN and RAMLOCK options using tmpfs on /var/run and
     /var/lock (Closes: #423405, #481546, #564635, #607136, #620735).
     Additionally, /run/shm replaces /dev/shm and may share the same
     tmpfs as /run if RAMSHM is set to "no" in /etc/default/rcS.  /tmp
     may also be configured to be a tmpfs if RAMTMP is set to "yes" in
     /etc/default/rcS.  /tmp may also be configured to use /run directly if
     it is symlinked to /run/tmp, for example.
     Summary:
       /var/run → /run
       /var/lock → /run/lock
       /dev/shm → /run/shm
       /lib/init/rw → /run (not transitioned automatically)
       /dev/.* → /run (not transitioned automatically)
     These changes do not take effect until the system is rebooted as
     is currently done for /lib/init/rw setup.  Prior to a reboot, the
     paths are made available via bind/nullfs/firmlink mounts, depending on
     the platform.  Following a reboot, the old paths will be converted to
     symlinks, or bind/nullfs/firmlink mounts where symlinking is not
     possible, to allow access via either the old or new paths, to permit
     programs using the old paths to transition to use the new paths for
     wheezy.
     - debian/initscripts.postinst:
       Take chroot detection logic from udev postinst (existing logic was
       broken).  Add detection logic for vserver environments and Hurd.
       Trigger reboot to complete transition.
       If the system has not yet transitioned to a tmpfs-based /run, set up
       bind mounts as follows:
         /var/run → /run
         /var/lock → /run/lock
         /dev/shm → /run/shm
       On reboot, the system will complete the migration to a tmpfs-based
       /run; this creates the directory heierachy from the old paths to
       enable the use of the new /run paths prior to a restart.  This means
       packages may transition to using /run with a versioned dependency
       upon initscripts.
       Remove special handling for RAMRUN and RAMLOCK, which is now taken
       care of by /run.
       If in a chroot environment, just create symlinks from the new names
       to the existing locations, since otherwise the changes would be
       lost, and since rcS scripts aren't run the transition won't
       complete.
     - debian/src/initscripts/Makefile:
       Provide top-level /run.
     - debian/src/initscripts/doc/README.Debian:
       Document new use of RUN_SIZE and LOCK_SIZE.
       Document use of /run rather than /lib/init/rw.
       Document use of SHM_SIZE and TMP_SIZE.
     - debian/src/initscripts/etc/init.d/checkroot.sh:
       Use /run in place of /lib/init/rw.
     - debian/src/initscripts/etc/default/tmpfs:
       Document TMPFS_SIZE, RUN_SIZE and LOCK_SIZE (Closes: #483643).
       Document TMP_SIZE and SHM_SIZE.
     - debian/src/initscripts/etc/init.d/mountkernfs.sh:
       Create /run, /run/sendsigs.omit.d and /run/lock.
       Mount /run/lock as a separate tmpfs if RAMLOCK=yes.
       /run/lock has 01777 permissions to match /var/lock.
       Mount /tmp as a separate tmpfs if RAMTMP=yes or / is being mounted
       read-only (Closes: #503805, #585543).
       Drop mounting of /var/run and /var/lock.
     - debian/src/initscripts/etc/init.d/mountdevsubfs.sh:
       Create /run/shm.  Mount /run/shm as a separate tmpfs if RAMSHM=yes.
     - debian/src/initscripts/etc/init.d/mtab.sh:
       domtab mirrors behaviour of domount in mount-functions exactly, to
       prevent duplicate mounts (required for bind mount support).
       Bind mount /run/init and drop mounting of /var/run.  Mount /run/lock
       in place of /var/lock.
       Mount /tmp if RAMTMP=yes.
       Mount /run/shm if RAMSHM=yes.
     - debian/src/initscripts/etc/init.d/sendsigs:
       Use new paths:
         files: /run/sendsigs.omit /lib/init/rw/sendsigs.omit
         dirs: /run/sendsigs.omit.d/ /lib/init/rw/sendsigs.omit.d/
     - debian/src/initscripts/etc/init.d/umountfs:
       Ignore /run.  Continue to ignore /lib/init/rw in order to handle
       clean shutdown.  No longer ignore /var/run and /var/lock.
     - debian/src/initscripts/etc/init.d/umountnfs.sh:
       Check for presence of .ramfs than configuration variable when
       skipping /var/run and /var/lock.
       Ignore /run.  Continue to ignore /lib/init/rw in order to handle
       clean shutdown.  No longer ignore /var/run and /var/lock.
     - debian/src/initscripts/lib/init/bootclean.sh
       Don't clean /var/run and /var/lock (Closes: #378776).  Because
       these directories are now a tmpfs, cleaning no longer makes sense.
     - debian/src/initscripts/lib/init/tmpfs.sh:
       Read /etc/default/tmpfs and provide defaults if unset.
     - debian/src/initscripts/lib/init/mount-functions.sh:
       Support bind mounts in domount() (Closes: #353943).
       Drop support for mounting /var/run and /var/lock as separate
       tmpfs filesystems.  Symlink /var/run to /run and /var/lock to
       /run/lock if possible.  If /var/run and /var/lock are directories,
       attempt to remove and symlink if successful, or else bind mount.
     - debian/src/initscripts/lib/init/vars.sh:
       Read /etc/default/rcS and provide defaults if unset.
     - debian/src/initscripts/man/rcS.5:
       Drop documentation of RAMRUN.
       Update documentation for RAMLOCK (Closes: #406685).
       Document RAMTMP and RAMSHM.
     - debian/src/initscripts/share/default.rcS:
       Remove RAMRUN.
       Add RAMSHM and RAMTMP.
       RAMLOCK, RAMSHM and RAMTMP default to enabled for new installs.
 .
   [ Michael Biebl ]
   * Remove dead usplash support code (Closes: #599241, #599734, #612594).
 .
   [ Martin F. Krafft ]
   * Add comments to /etc/default/rcS (Closes: #530582).
 .
   [ Samuel Thibault ]
   Hurd portability for initscripts postinst and init scripts.
   Hurd does not currently support tmpfs mounts, but will do in the
   future.  Use firmlinks in place of bind mounts.
Checksums-Sha1: 
 be9d988363ea206734abf37e28aa05c0e6562b4e 1532 sysvinit_2.88dsf-13.3.dsc
 de3efda313a5c2f31d54eadeeff76b161da65156 172561 sysvinit_2.88dsf-13.3.diff.gz
 b78268833a44e50f9cd3e2f9c973e586e1950092 123172 sysvinit_2.88dsf-13.3_amd64.deb
 124dd7d5976ab932b12836aa034285adf38ebadc 123756 sysvinit-utils_2.88dsf-13.3_amd64.deb
 549bda85e582e268f0c845f510af1f15c0a78e23 75664 initscripts_2.88dsf-13.3_amd64.deb
 b2825862ee97b31ff274955be71a231546dd7c83 76464 sysv-rc_2.88dsf-13.3_all.deb
Checksums-Sha256: 
 07d58ffae680f2875127b9192a7e2d9e4ac5d43df44592d5c353992e869352a6 1532 sysvinit_2.88dsf-13.3.dsc
 661a477552f9be1a0f1f112b392a0f18f6007ca5490fc94079c771f90671cfcf 172561 sysvinit_2.88dsf-13.3.diff.gz
 4c1472aef05058062225daddf11d4390824a73b7bdea886508b26b1f6722495f 123172 sysvinit_2.88dsf-13.3_amd64.deb
 7990833fcea2c8b52bf91f7e2dfce748ec285270926aa2f86ffc3dcf8e9881fd 123756 sysvinit-utils_2.88dsf-13.3_amd64.deb
 5f9af575d548648a96c07412df3c4a83fde14575b3cc714b16203211736795b2 75664 initscripts_2.88dsf-13.3_amd64.deb
 dd1393d8206bb5b320d42f92b100636108396edb59fb993a69823aea04cae57a 76464 sysv-rc_2.88dsf-13.3_all.deb
Files: 
 ce5a50face05beafa6cab9642a0bb95a 1532 admin required sysvinit_2.88dsf-13.3.dsc
 6dbe29e91350698e63857ae24de5ffbf 172561 admin required sysvinit_2.88dsf-13.3.diff.gz
 7518abcfd4f81b48129b56d32e0ae9a8 123172 admin required sysvinit_2.88dsf-13.3_amd64.deb
 9a672f235a3a1cae9b0435ee3397c41c 123756 admin required sysvinit-utils_2.88dsf-13.3_amd64.deb
 281d99c48bda7dd1abf32b74c5f91ab2 75664 admin required initscripts_2.88dsf-13.3_amd64.deb
 c802c38a538c6e39e05b6d079833e4f9 76464 admin required sysv-rc_2.88dsf-13.3_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iEYEAREDAAYFAk2puNAACgkQVcFcaSW/uEgMKwCg7OelUXpt8gjS5XCQJ6fdnL8N
cvMAniD5GrfZsHPB8tn1OIkv3OQNnDoB
=KEGe
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 20 Jun 2011 07:37:04 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 06:20:37 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.